#!/usr/bin/perl -w

#--------------------------------------------------------------------
# FICHERO:  apsg.pl
# OBJETIVO: Interfaz a apt-cache search * | grep -i *
# AUTOR:    Pedro Reina
# FECHA:    D.10.2.2002
#--------------------------------------------------------------------

#---------------------------------
# Declaracin de mdulos
#---------------------------------

use strict;              # Comprobaciones estrictas
use Gtk;                 # Interfaz grfico GTK

#---------------------------------
# Declaracin de variables Perl
#---------------------------------

my $TextoApt;            # El texto que se manda a apt-cache
my $TextoGrep;           # El texto que se manda a grep
my $Respuesta;           # La respuesta final a la orden

#---------------------------------
# Declaracin de variables GTK
#---------------------------------

my $Ventana;             # Ventana de la aplicacin
my $Estado;              # Barra de estado
my $Contexto;            # Contexto para la barra de estado
my $EtiquetaApt;         # Para escribir la orden apt-cache
my $EtiquetaGrep;        # Para escribir la orden grep
my $BotonCerrar;         # El botn para cerrar la aplicacin
my $BotonAyuda;          # El botn para lanzar la ayuda
my $BotonAcerca;         # El botn para lanzar el "Acerca de"
my $BotonBuscar;         # El botn para lanzar la bsqueda
my $BotonLimpiar;        # El botn para borrar todo
my $Caja;                # Un contenedor para los controles
my $CajaOrdenes;         # Un contenedor para botones de orden
my $CajaRespuesta;       # Un contenedor para poner la respuesta
my $CajaBotones;         # Un contenedor para poner los botones de abajo
my $EntradaApt;          # El texto que se mandar a apt-cache
my $EntradaGrep;         # El texto que se mandar a grep
my $AreaRespuesta;       # La zona de texto en que mostraremos el resultado
my $Desplazamiento;      # La barra de desplazamiento

my $IndApt;              # Indicacin para la entrada para apt-cache
my $IndGrep;             # Indicacin para la entrada para grep
my $IndBuscar;           # Indicacin para el botn Buscar
my $IndLimpiar;          # Indicacin para el botn Limpiar
my $IndRespuesta;        # Indicacin para la zona de respuesta
my $IndCerrar;           # Indicacin para el botn de Cerrar
my $IndAyuda;            # Indicacin para el botn de Ayuda
my $IndAcerca;           # Indicacin para el botn de Acerca
my $IndEstado;           # Indicacin para la barra de estado

#---------------------------------
# Programa principal
#---------------------------------

# Arrancamos el motor GTK;
init Gtk;

# Creamos la ventana principal
$Ventana = new Gtk::Window ("toplevel");

# Le ponemos un ttulo
$Ventana->set_title ("acsg");

# Le ponemos un poquito de borde
$Ventana->border_width (10);

# Definimos el tamao que nos gusta
$Ventana->set_usize (600, 400);

# Creamos la caja para poner los controles
$Caja = new Gtk::VBox (0, 0);

# Definimos la etiqueta para informar al usuario
$EtiquetaApt = new Gtk::Label ("apt-cache search");

# Debe tener alineacin izquierda
$EtiquetaApt->set_alignment (0, 0);

# Aadimos la etiqueta a la caja
$Caja->pack_start ($EtiquetaApt, 0, 0, 2);

# Mostramos la etiqueta
$EtiquetaApt->show();

# Creamos la entrada a apt-cache
$EntradaApt = new Gtk::Entry (20);

# Aadimos la entrada a la caja
$Caja->pack_start ($EntradaApt, 0, 0, 2);

# Mostramos la entrada
$EntradaApt->show();

# Definimos la etiqueta para informar al usuario
$EtiquetaGrep = new Gtk::Label ("grep");

# Debe tener alineacin izquierda
$EtiquetaGrep->set_alignment (0, 0);

# Aadimos la etiqueta a la caja
$Caja->pack_start ($EtiquetaGrep, 0, 0, 2);

# Mostramos la etiqueta
$EtiquetaGrep->show();

# Creamos la entrada a apt-cache
$EntradaGrep = new Gtk::Entry (20);

# Aadimos la entrada a la caja
$Caja->pack_start ($EntradaGrep, 0, 0, 2);

# Mostramos la entrada
$EntradaGrep->show();

# Creamos la caja para poner los botones de orden
$CajaOrdenes = new Gtk::HBox (0, 10);

# Definimos el botn de lanzar la bsqueda
$BotonBuscar = new Gtk::Button ("Buscar");

# Aadimos el botn a la caja
$CajaOrdenes->pack_start ($BotonBuscar, 1, 1, 0);

# Mostramos el botn
$BotonBuscar->show();

# Registramos la llamada para lanzar la bsqueda
$BotonBuscar->signal_connect ("clicked", \&Busca);

# Definimos el botn de borrar entrada y respuesta
$BotonLimpiar = new Gtk::Button ("Limpiar");

# Aadimos el botn a la caja
$CajaOrdenes->pack_start ($BotonLimpiar, 1, 1, 0);

# Mostramos el botn
$BotonLimpiar->show();

# Registramos la llamada para borrar todo
$BotonLimpiar->signal_connect ("clicked", \&Limpia);

# Aadimos la caja de rdenes a la caja
$Caja->pack_start ($CajaOrdenes, 0, 0, 2);

# Mostramos la caja de rdenes
$CajaOrdenes->show();

# Creamos la caja para poner la respuesta
$CajaRespuesta = new Gtk::HBox (0, 0);

# Definimos el rea de texto para mostrar la respuesta
$AreaRespuesta = new Gtk::Text (undef, undef);

# No permitimos editar su texto
$AreaRespuesta->set_editable (0);

# La aadimos a la caja de respuesta
$CajaRespuesta->pack_start ($AreaRespuesta, 1, 1, 0);

# La mostramos
$AreaRespuesta->show();

# Definimos la barra de desplazamiento
$Desplazamiento = new Gtk::VScrollbar ($AreaRespuesta->vadj);

# La aadimos a la caja de respuesta
$CajaRespuesta->pack_start ($Desplazamiento, 0, 0, 0);

# La mostramos
$Desplazamiento->show();

# Aadimos la caja de respuesta a la caja
$Caja->pack_start ($CajaRespuesta, 1, 1, 2);

# Mostramos la caja de respuesta
$CajaRespuesta->show();

# Creamos la caja para poner los botones de abajo
$CajaBotones = new Gtk::HBox (0, 10);

# Definimos el botn de cerrar la aplicacin
$BotonCerrar = new Gtk::Button ("Cerrar");

# Aadimos el botn a la caja de botones
$CajaBotones->pack_start ($BotonCerrar, 1, 1, 0);

# Mostramos el botn
$BotonCerrar->show();

# Definimos el botn de pedir ayuda
$BotonAyuda = new Gtk::Button ("Ayuda");

# Aadimos el botn a la caja de botones
$CajaBotones->pack_start ($BotonAyuda, 1, 1, 0);

# Mostramos el botn
$BotonAyuda->show();

# Registramos la llamada para lanzar la ayuda
$BotonAyuda->signal_connect ("clicked", \&Ayuda);

# Definimos el botn de pedir el Acerca
$BotonAcerca = new Gtk::Button ("Acerca");

# Aadimos el botn a la caja de botones
$CajaBotones->pack_start ($BotonAcerca, 1, 1, 0);

# Mostramos el botn
$BotonAcerca->show();

# Registramos la llamada para lanzar el Acerca
$BotonAcerca->signal_connect ("clicked", \&Acerca);

# Aadimos la caja de botones a la caja
$Caja->pack_start ($CajaBotones, 0, 0, 2);

# Mostramos la caja de botones
$CajaBotones->show();

# Definimos la barra de estado
$Estado = new Gtk::Statusbar();

# Aadimos la barra a la caja
$Caja->pack_start ($Estado, 0, 0, 2);

# Mostramos la barra
$Estado->show();

# Pedimos un contexto para la barra de estado
$Contexto = $Estado->get_context_id ("General");

# Ponemos un mensaje
$Estado->push ($Contexto, "Preparado");

# Registramos las llamadas para cerrar la aplicacin
$Ventana->signal_connect ("delete_event", \&CerrarAplicacion);
$BotonCerrar->signal_connect ("clicked", \&CerrarAplicacion);

# Aadimos la caja a la ventana
$Ventana->add ($Caja);

# Mostramos la caja
$Caja->show();

# Definimos los "tooltips"
$IndApt = new Gtk::Tooltips();
$IndGrep = new Gtk::Tooltips();
$IndBuscar = new Gtk::Tooltips();
$IndLimpiar = new Gtk::Tooltips();
$IndRespuesta = new Gtk::Tooltips();
$IndCerrar = new Gtk::Tooltips();
$IndAyuda = new Gtk::Tooltips();
$IndAcerca = new Gtk::Tooltips();
$IndEstado = new Gtk::Tooltips();  # Parece que no funciona

# Y los asignamos
$IndApt->set_tip ($EntradaApt, "Lo que quieres buscar", "");
$IndGrep->set_tip ($EntradaGrep, "Puedes aplicar este filtro", "");
$IndBuscar->set_tip ($BotonBuscar, "Comienza la bsqueda", "");
$IndLimpiar->set_tip ($BotonLimpiar, "Limpia la entrada y la respuesta", "");
$IndRespuesta->set_tip ($AreaRespuesta, "Aqu aparecen los resultados de la bsqueda", "");
$IndCerrar->set_tip ($BotonCerrar, "Cierra la aplicacin", "");
$IndAyuda->set_tip ($BotonAyuda, "Para saber lo que significa todo", "");
$IndAcerca->set_tip ($BotonAcerca, "Para saber el responsable de esto", "");
$IndEstado->set_tip ($Estado, "Muestra el estado de la aplicacin", "");

# Mostramos la ventana
$Ventana->show();

# El resto es cosa de GTK
main Gtk;

# As que hasta aqu no se debera llegar nunca
exit (0);

#---------------------------------
# Funciones
#---------------------------------

sub CerrarAplicacion
  {
  Gtk->exit (0);
  return (0);
  }

sub Busca
  {
  $Estado->push ($Contexto, "Buscando...");
  $Estado->activate();  # No funciona
  $TextoApt = $EntradaApt->get_text();
  $TextoGrep = $EntradaGrep->get_text();
  if ( $TextoGrep )
    {
    $Respuesta = qx (apt-cache search $TextoApt | grep -i $TextoGrep);
    }
  else
    {
    $Respuesta = qx (apt-cache search $TextoApt);
    }
  $AreaRespuesta->insert (undef, undef, undef, $Respuesta);
  $Estado->push ($Contexto, "Terminado");
  }

sub Limpia
  {
  $EntradaApt->set_text ("");
  $EntradaGrep->set_text ("");
  $AreaRespuesta->delete_text (0, -1);
  $Estado->push ($Contexto, "Preparado");
  }

sub Ayuda
  {
  $Estado->push ($Contexto, "Busca en la base de datos de paquetes Debian");
  }

sub Acerca
  {
  $Estado->push ($Contexto, "Pedro Reina, Marzo 2001");
  }

